TYPE RGB
    r AS INTEGER
    g AS INTEGER
    b AS INTEGER
END TYPE

DECLARE SUB GetRGBValue (which AS STRING, colour AS RGB)
DECLARE SUB CalculateColourSpread (array() AS ANY, light AS ANY, dark AS ANY)

REM A quick program to change the sea colours in a WORMS:Reinforcements file.

REM ------------------------------------------------------------------------

DIM r AS STRING * 1
DIM g AS STRING * 1
DIM b AS STRING * 1
DIM fin AS STRING
DIM fout AS STRING
DIM i AS INTEGER
DIM fp AS LONG
DIM light AS RGB
DIM dark AS RGB
DIM array(16) AS RGB

REM ------------------------------------------------------------------------

INPUT "Enter the source filename: ", fin
INPUT "Enter the destination filename: ", fout

GetRGBValue "light", light
GetRGBValue "dark", dark

PRINT light.r, light.g, light.b
PRINT dark.r, dark.g, dark.b

CalculateColourSpread array(), light, dark

SHELL "copy " + fin$ + " " + fout$

OPEN fout FOR BINARY AS #1

fp = LOF(1) - 767 + (3 * 80)

FOR i = 0 TO 15

    r = CHR$(array(i).r)
    g = CHR$(array(i).g)
    b = CHR$(array(i).b)
    PUT #1, fp, r
    PUT #1, fp + 1, g
    PUT #1, fp + 2, b

    fp = fp + 3

NEXT

CLOSE

END

SUB CalculateColourSpread (array() AS RGB, light AS RGB, dark AS RGB)
DIM i AS INTEGER
DIM rstep AS SINGLE
DIM gstep AS SINGLE
DIM bstep AS SINGLE

    rstep = (light.r - dark.r) / 15
    gstep = (light.g - dark.g) / 15
    bstep = (light.b - dark.b) / 15

    FOR i = 0 TO 15
        array(i).r = dark.r + (rstep * i)
        array(i).g = dark.g + (gstep * i)
        array(i).b = dark.b + (bstep * i)
    NEXT

END SUB

SUB GetRGBValue (which AS STRING, colour AS RGB)
DIM user AS STRING

    PRINT "Input the "; which; " colour (R/G/B): ";
    INPUT user

    colour.r = VAL(user)
   
    user = MID$(user, INSTR(user, "/") + 1)
    colour.g = VAL(user)
   
    user = MID$(user, INSTR(user, "/") + 1)
    colour.b = VAL(user)

END SUB

